/*
 * 拉新活动信息
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class PullNewActController : BaseController
    {
        public PullNewActController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 拉新活动信息列表

        /// <summary>
        /// 根据条件查询拉新活动信息列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(PullNewAct data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            string Condition = "";
            Condition += "ProductType:\"" + data.ProductType + "\",";
Condition += "ProductName:\"" + data.ProductName + "\",";

            if (!string.IsNullOrEmpty(Condition))
            { 
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询拉新活动信息列表

        /// <summary>
        /// 拉新活动信息列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(PullNewAct data, int page = 1, int limit = 30)
        {
            
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            
            Fields.Add("CreateDate", "3"); //时间
Fields.Add("ProductType", "1"); //产品类型
Fields.Add("ProductName", "2"); //产品名称

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("PullNewAct", Fields, "Id desc", "0", page, limit, " and Status>-1");
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                
            }
            return Json(obj);
        }

        #endregion

        #region 增加拉新活动信息

        /// <summary>
        /// 增加或修改拉新活动信息信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            return View();
        }

        #endregion

        #region 增加拉新活动信息

        /// <summary>
        /// 增加或修改拉新活动信息信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(PullNewAct data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("SnDelayDay", data.SnDelayDay); //机具延时时间
Fields.Add("ProductType", data.ProductType); //产品类型
Fields.Add("ProductName", data.ProductName); //产品名称
Fields.Add("ActStdCond", data.ActStdCond); //拉新活动达标条件
Fields.Add("ActEffectStartDate", data.ActEffectStartDate); //有效开始时间
Fields.Add("ActEffectEndDate", data.ActEffectEndDate); //有效结束时间
Fields.Add("Remark", data.Remark); //备注

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("PullNewAct", Fields, 0);
            AddSysLog(data.Id.ToString(), "PullNewAct", "add");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 修改拉新活动信息

        /// <summary>
        /// 增加或修改拉新活动信息信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            PullNewAct editData = db.PullNewAct.FirstOrDefault(m => m.Id == Id) ?? new PullNewAct();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改拉新活动信息

        /// <summary>
        /// 增加或修改拉新活动信息信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(PullNewAct data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("SnDelayDay", data.SnDelayDay); //机具延时时间
Fields.Add("ProductType", data.ProductType); //产品类型
Fields.Add("ProductName", data.ProductName); //产品名称
Fields.Add("ActStdCond", data.ActStdCond); //拉新活动达标条件
Fields.Add("ActEffectStartDate", data.ActEffectStartDate); //有效开始时间
Fields.Add("ActEffectEndDate", data.ActEffectEndDate); //有效结束时间
Fields.Add("Remark", data.Remark); //备注

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("PullNewAct", Fields, data.Id);
            AddSysLog(data.Id.ToString(),"PullNewAct","update");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 删除拉新活动信息信息

        /// <summary>
        /// 删除拉新活动信息信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"PullNewAct","del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("PullNewAct", Fields, id);
            }
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"PullNewAct","open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("PullNewAct", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"PullNewAct","close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("PullNewAct", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("PullNewAct", Sort, Id);
            
            AddSysLog(Id.ToString(), "PullNewAct", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                db.PullNewAct.Add(new PullNewAct()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    
                });
                db.SaveChanges();
            }
            AddSysLog("0", "PullNewAct", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(PullNewAct data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间
Fields.Add("ProductType", "1"); //产品类型
Fields.Add("ProductName", "2"); //产品名称

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("PullNewAct", Fields, "Id desc", "0", 1, 20000, "", "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                
            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "PullNewAct", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
